Bug 903501

Summary: Make next steps from 'Installation Options' dialog clearer
Product: [Fedora] Fedora Reporter: Adam Williamson <awilliam>
Component: anacondaAssignee: Chris Lumens <clumens>
Status: CLOSED CURRENTRELEASE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: unspecified    
Version: 19CC: armbru, duffy, g.kaviyarasu, jjardon, jonathan, nonamedotc, sbueno, stephent98, vanmeeuwen+fedora
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: All   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-05-12 18:00:51 EDT Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Attachments:
Description Flags
Mockup with Changes for Enough Space Dialog
none
Mockup with Changes for No Space Dialog
none
Mockup with Changes for Enough Space Dialog
none
Mockup with Changes for No Space Dialog none

Description Adam Williamson 2013-01-24 03:13:07 EST
As we're all aware, one of the main themes of negative comment on the F18 installer is confusion and uncertainty in the storage configuration workflow. This is one of several proposals to improve on that.

I've read multiple reports that people found the two versions of the 'Installation Options' dialog confusing.

Both incarnations of this dialog offer two basic ways forward:

1) Go to manual partitioning
2) Go to guided partitioning

The 'plenty of space' dialog represents these as:

1) 'Let me customize the partitioning of the disks instead' box checked, button labelled Continue
2) 'Let me customize the partitioning of the disks instead' box unchecked, button labelled Continue

The 'not enough space' dialog represents these as:

1) 'I don't need help; let me customize disk partitioning.' box checked, button labelled Reclaim space
2) 'I don't need help; let me customize disk partitioning.' box unchecked, button labelled Reclaim space

I can kind of see where this approach comes from - it's the functional approach, trying to describe what high-level action will result - but it seems a bit cockamamie. It's clearly confusing users. Aside from just not knowing what the hell is going on, one common refrain is that the 'Reclaim space' button is scary, and sounds as if the installer is about to do something unspecified to your disks.

May I suggest something a bit more direct?

For 'plenty of space':

1) 'Let me customize the partitioning of the disks instead' box checked, button labelled 'Partition manually' or 'Customize partitioning'
2) 'Let me customize the partitioning of the disks instead' box unchecked, button labelled 'Done' (not continue, because at this point you are in fact Done)

For 'not enough space' (yes, I'm proposing using the same checkbox label as the 'plenty of space' dialog):

1) Box labelled 'Let me customize the partitioning of the disks instead' and checked, button labelled 'Partition manually' or 'Customize partitioning'
2) Box labelled 'Let me customize the partitioning of the disks instead' and unchecked, button labelled 'Plan space reclamation'

The checkbox label from 'plenty of space' - "Let me customize the partitioning of the disks instead" - seems just as good for 'not enough space', to me, and it would make the two cases more consistent. I think it makes things rather clearer to just have the button label say something directly about custom partitioning when it's going to lead to custom partitioning, rather than have it be action-based. And I think 'Plan space reclamation' is a deal less scary than 'Reclaim space', though if someone can think of a simpler way of putting it that would be even better. Taken together I think these changes would make the path from here on much clearer - the changing label on the button depending on the checkbox state should make it fairly clear that this is a 'branch point', as well.
Comment 1 Steve Tyler 2013-01-24 10:37:03 EST
(In reply to comment #0)
...
> ... button labelled 'Partition manually' or 'Customize partitioning'
...

"Manual Partitioning" per Apple Human Interface Guidelines:

"Create a label that names a thing or describes an action; also, use title-style capitalization. An icon button that functions as a pane-switcher should name a thing, such as Network or Accounts. ..."

OS X Human Interface Guidelines
UI Element Guidelines: Controls
https://developer.apple.com/library/mac/#documentation/UserExperience/Conceptual/AppleHIGuidelines/Controls/Controls.html
Comment 2 Adam Williamson 2013-01-24 11:51:19 EST
Steve: anaconda consistently uses natural casing for buttons, just look at the others on the screen.
Comment 3 Steve Tyler 2013-01-24 14:35:42 EST
(In reply to comment #1)
> (In reply to comment #0)
> ...
> > ... button labelled 'Partition manually' or 'Customize partitioning'
> ...
> 
> "Manual Partitioning" per Apple Human Interface Guidelines:
> 
> "... An icon button that functions as a pane-switcher
                                        ^^^^^^^^^^^^^^^
> should name a thing, such as Network or Accounts. ..."
  ^^^^^^^^^^^^^^^^^^^

IOW, the button label should match the name of the Manual Partitioning dialog.
Comment 4 Adam Williamson 2013-01-24 18:04:54 EST
Mo reports via IRC:

<mizmo> adamw, i dont think we can change the text of the button based on whether or not the checkbox is checked
<adamw> can we not? boo.
<mizmo> thats the trick with this one :-/
<adamw> i see :/ yeah having to have a single label kind of sucks

so that would make my idea impossible unfortunately. We're now thinking along the lines of having multiple buttons rather than the checkbox, but that might have its own problems. Mo's going to work on it tomorrow.
Comment 5 Steve Tyler 2013-01-24 22:16:00 EST
The button label could be changed based on the state of the checkbox, but that would mean that one button does two different things and would force the user to remember one of the button labels, because it is not displayed.

ATM, two buttons that branch to two different storage configuration dialogs sound like a good idea:

o Guided Storage Configuration
o Manual Storage Configuration
Comment 6 Chris Lumens 2013-01-29 10:43:16 EST
Technically, we certainly can change the text of a button based on something else happening.  Whether we want to or not is a different story, though.

We need to be careful with adding more buttons to these dialogs because they're already getting a little button-heavy.  There's three fairly verbose buttons on there now, and four definitely wouldn't help to make it less wordy.
Comment 7 Adam Williamson 2013-01-30 16:15:35 EST
So we discussed this in #anaconda today and came up with some changes that everyone agrees ought to make the 'custom partitioning' path a tad clearer here. We did not address the problem I mentioned as "one common refrain is that the 'Reclaim space' button is scary, and sounds as if the installer is about to do something unspecified to your disks".

So I'm going to open another bug to split that problem off, and summarize the changes we planned to address the other issues here, so we have them noted somewhere. sbueno is working on a mockup of the changes, I believe.

These changes should be applied to both versions of the dialog - 'enough free space' and 'not enough free space'.

1. The "Let me customize the partitioning of the disks instead" / "I don't need help; let me customize disk partitioning." checkbox should be killed.

2. The button "Modify software selection" should be killed.

3. A "Customize partitioning" or "Manual partitioning" button should be added.

4. The buttons should be re-aligned so that "Cancel" is at far left and "Continue" / "Reclaim space" and "Customize partitioning" are together at far right, with as much space as possible between them (possibly, 'continue / reclaim' and 'customize' could even be stacked vertically?)

These are the changes already agreed upon. Looking at a screenshot and considering the impact of the changes, I think we need to make further changes too: I will add those as separate comments for clarity.
Comment 8 Adam Williamson 2013-01-30 16:31:16 EST
So, looking at the current dialog and mentally applying the above changes, I see two problems created. Let's take 'em one at a time, here's the first:

1. The 'custom partitioning' possibility is no longer acknowledged in the dialog text - it's just a button floating there.

2. The "Cancel & add more disks" button is a bit too specific, now we've lost "Modify software selection". We need a more generic cancel action, and we need to acknowledge the 'add more disks' and 'modify software selection' possibilities in the text.

Both of these really relate to the paragraph "You don't have enough space available to install Fedora, but we can help you reclaim space by shrinking or removing existing partitions" in the text.

How about we change that to read:

You don't have enough space available to install Fedora with your current software selection. We can show your existing storage volumes and let you choose some to be deleted or shrunk as part of installation, then we will handle creating new volumes. Alternatively, you can use (custom/manual) partitioning to take full control of storage configuration. Or you can return to the main screen and then change your software selection to take up less space, or add more disks so there is more free space available.

The 'Cancel & add more disks' button would become just 'Cancel', or 'Main screen', or something.

We could then change the "Reclaim space" button to something that matches the text better, I guess, like "Choose volumes to delete or shrink"?

It's longer, but the dialog isn't really too large at present - there's space even in German! - and we saved space by ditching the checkbox. I think it makes the next steps from this dialog much clearer, and it solves the "Will it just eat my disks when I click "Reclaim space"?" problem too.

Modifications / improvements welcome, of course, but I'm pretty sure we need to make some changes to the text at least, to go along with the button changes.
Comment 9 Adam Williamson 2013-01-30 17:14:50 EST
For the 'plenty of space' version of the page, current text reads:

"You have plenty of space to install Fedora, so we can automatically configure the rest of the installation for you.

You're all set!"

Proposed replacement text:

"You have plenty of space to install Fedora, so we can automatically create storage volumes for you as part of the installation process. Alternatively, you can use (custom/manual) partitioning to take full control of storage configuration."

The 'Continue' button could read 'Automatic partitioning' to contrast with 'Manual partitioning', or something like that.

Is there really any value to having the 'Cancel & add more disks' button here? It's not like it's needed as a get-out clause - if you stuffed up you can just re-do the spoke. We could just ditch it from this version of the dialog entirely...
Comment 10 Adam Williamson 2013-01-30 17:16:58 EST
In both versions of the text we could replace references to 'volumes' and 'storage volumes' with 'partitions', of course, that's the Ongoing Debate we have - 'partitions' is less accurate but more concise and probably better understood.
Comment 11 Mukundan Ragavan 2013-01-30 22:10:00 EST
just adding myself to cc
Comment 12 Chris Lumens 2013-01-31 14:39:16 EST
*** Bug 891576 has been marked as a duplicate of this bug. ***
Comment 13 stephaniemanuel16 2013-01-31 14:40:18 EST
Created attachment 691200 [details]
Mockup with Changes for Enough Space Dialog
Comment 14 stephaniemanuel16 2013-01-31 14:40:47 EST
Created attachment 691201 [details]
Mockup with Changes for No Space Dialog
Comment 15 Máirín Duffy 2013-01-31 16:31:20 EST
Okay, we had another discussion around some of Adam's comments in comment 8 as well as around dlehman's concern that you can't access reclaim space if you have enough space - only if you don't have enough. I'm going to post updated mockups for each screen based on that discussion.
Comment 16 Máirín Duffy 2013-01-31 16:33:49 EST
Created attachment 691259 [details]
Mockup with Changes for Enough Space Dialog
Comment 17 Máirín Duffy 2013-01-31 16:34:13 EST
Created attachment 691260 [details]
Mockup with Changes for No Space Dialog
Comment 18 Chris Lumens 2013-01-31 16:43:35 EST
I am not accepting any more changes for this bug.  What's in comment 16 and comment 17 is what's getting done.
Comment 19 Adam Williamson 2013-01-31 16:50:44 EST
Er, sorry Chris, but I was typing this as you typed your comment, and I think it's important. We thrashed out the *design* carefully, but the text in it was not discussed at all and has some issues. Comment #17 is also an earlier mockup than comment #16 and I don't know if Mo / Samantha actually intended that the radio button layout be used only for the Enough Space dialog and a completely different layout used for the No Space dialog - that doesn't seem logical. I think at least it'd be good if Mo could clarify that.

----

Wait, do we actually want to present the interface differently in the two cases? I was assuming we'd all agreed the radio button layout was superior and we'd use it for both cases - the 'No Space' case would only have the bottom two radio buttons, and the obvious tweaks to the text.

I'm strongly on board with the Enough Space Dialog mockup so far as the design goes, I think that's the best plan we have so far and clearly superior to anything else we've discussed so far. I'd just suggest some relatively minor text tweaks:

1. If we wanted to go really belt-and-braces on the 'automatically configure' text we could link it more clearly to the fact that we're just 'automatically configuring' that X GB of free space:

"Automatically configure my Fedora installation to the 4 GB of space on the disk(s) I selected and return me to the main menu."

2. We should probably explain what happens once you're done shrinking/resizing, so just append a bit to that text:

"I want more space. Guide me through shrinking and/or removing partitions so I can have more space for Fedora, then automatically configure my installation and return me to the main menu."

3. The custom part text is bad, it's obviously leaked back in from an old mockup - 'review/modify' was the key phrase in oldUI that meant 'use autopart, then send me to custom partitioning to modify what it did'. We don't have that workflow any more, we should definitely avoid using that phrasing. I knocked this together, but I don't insist on it, the idea is just 'write some text that follows the basic pattern of the other two options, describes clearly what this option does and why you might want to use it':

"Let me handle partitioning manually: I need more control over device types and sizes, or I want to use existing partitions for my Fedora installation."

4. We could add a line that explains what the 'Partition scheme configuration' setting actually *does* - it would be hidden behind the expander with the dropdown itself:

"The chosen partition type will be used for automatic configuration, or as the default type for newly-created partitions in manual partitioning."

5. Finally we're just left with the relatively small problem of the 'Cancel' button - it's now not just 'cancel and add more disks' but also should cover 'cancel and change software selection' too. We could just make it 'Cancel' and hope people figure out why they might want to use it? Or we could make it 'Cancel' and add text somewhere to suggest why you might want to Cancel.

But these are just refinements - I'm definitely a fan of the basic design idea there.
Comment 20 Fedora End Of Life 2013-04-03 16:19:46 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 21 Adam Williamson 2013-05-12 18:00:51 EDT
I still kinda like the improvements I suggested in comment #19, but we should probably close this out now. The major changes have been made.